Attribute VB_Name = "modMain"
Option Explicit

' Copyright (C) 2006 Kristian S. Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 
' Used when converting text box to numeric
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Const GWL_STYLE = (-16)
Const ES_NUMBER = &H2000&

Public Sub SetNumber(NumberText As TextBox, Flag As Boolean)

    Dim curstyle As Long, newstyle As Long

    ' Retrieve the window style
    curstyle = GetWindowLong(NumberText.hwnd, GWL_STYLE)

    ' Change the flag
    If Flag Then
        curstyle = curstyle Or ES_NUMBER
    Else
        curstyle = curstyle And (Not ES_NUMBER)
    End If

    ' Set the new style
    newstyle = SetWindowLong(NumberText.hwnd, GWL_STYLE, curstyle)
    
    ' Refresh textbox
    NumberText.Refresh
    
End Sub

Public Sub ExitApp()

    Dim Form As Form
    
    ' Run through all forms in the project, ...
    For Each Form In Forms
    
        ' Used to let the unload procedure know that it must not recreate forms
        Form.Tag = "FORCED"
    
        ' ... closing each of them
        Unload Form

    Next

End Sub
