VERSION 5.00
Begin VB.UserControl usrList 
   ClientHeight    =   6090
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4515
   ScaleHeight     =   406
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   301
   Begin VB.VScrollBar scrollPos 
      Height          =   4695
      Left            =   3600
      TabIndex        =   1
      Top             =   0
      Width           =   255
   End
   Begin VB.TextBox txtElement 
      Appearance      =   0  'Flat
      Height          =   285
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2055
   End
End
Attribute VB_Name = "usrList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Copyright (C) 2006 Kristian S. Stangeland

' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.

' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.

' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

' The array containing all information
Private aArray() As String
Private pElementCount As Long

Public Property Get ElementValue(ByVal Index As Long) As String

    ' Return the value
    ElementValue = aArray(Index)

End Property

Public Property Let ElementValue(ByVal Index As Long, ByVal vNewValue As String)

    ' Set the array element
    aArray(Index) = vNewValue

End Property

Public Property Get ElementCount() As Long

    ' Just return the private variable
    ElementCount = pElementCount

End Property

Public Property Let ElementCount(ByVal vNewValue As Long)

    ' Overlook invalid numbers
    If vNewValue < 0 Then
        Exit Property
    End If

    ' Change the private variable ...
    pElementCount = vNewValue
    
    ' Reallocate array
    ReDim Preserve aArray(vNewValue)
    
    ' ... and recreate controls if needed
    RefreshControls
    
End Property

Private Sub scrollPos_Change()

    ' Now change the content of each text box
    UpdateContent

End Sub

Private Sub txtElement_Change(Index As Integer)

    ' Change the corresponding element in the array
    aArray(Index + scrollPos.Value) = txtElement(Index).Text

End Sub

Private Sub UserControl_Resize()

    ' Refresh positions and count, if needed
    RefreshControls

End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    ' Set the different private variables
    pElementCount = PropBag.ReadProperty("ElementCount", 20)

End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    ' Save the properties
    PropBag.WriteProperty "ElementCount", pElementCount

End Sub

Public Sub UpdateContent()

    Dim Tell As Long
    
    ' Go through all text boxes ...
    For Tell = txtElement.LBound To txtElement.UBound

        ' ... setting its value off the current array
        txtElement(Tell).Text = aArray(Tell + scrollPos.Value)

    Next

End Sub

Public Sub RefreshControls()

    On Error Resume Next
    Dim Tell As Long, lngAmount As Long
    
    ' Now, if the amount of controls dosen't correspond to the hight of this control, recreate
    If txtElement.Count <> UserControl.ScaleHeight / txtElement(0).Height Then
    
        ' Remove all existing controls (beside the first)
        For Tell = txtElement.LBound + 1 To txtElement.UBound
            Unload txtElement(Tell)
        Next
        
        ' Firstly, find out how many controls we at max have to create
        lngAmount = (UserControl.ScaleHeight / txtElement(0).Height) - 1
        
        ' See then if there really are that many to create
        If lngAmount > pElementCount Then
            lngAmount = pElementCount
        End If
        
        ' Create the appropriate amount
        For Tell = 1 To lngAmount
        
            ' Create the control in it self
            Load txtElement(Tell)
            
            ' Initialize its properties
            txtElement(Tell).Visible = True
            txtElement(Tell).Top = Tell * (txtElement(0).Height - 1)
        
        Next

    End If

    ' Recalibrate the scroll
    If pElementCount - lngAmount > 0 Then
        scrollPos.Max = pElementCount - txtElement.Count
        scrollPos.Left = UserControl.ScaleWidth - scrollPos.Width
        scrollPos.Height = (txtElement(0).Height - 1) * txtElement.Count
        scrollPos.Visible = True
    Else
        ' No need for scrolling
        scrollPos.Visible = False
    End If
    
    ' Update the size of the different controls
    For Tell = txtElement.LBound To txtElement.UBound
    
        ' Set the width, according to the width of the control and whether or not the scoll is visible
        txtElement(Tell).Top = Tell * (txtElement(0).Height - 1)
        txtElement(Tell).Width = UserControl.ScaleWidth - IIf(scrollPos.Visible, scrollPos.Width, 0)
    
    Next

End Sub

